/* Angular-client joka käyttää websocket-serviceä
Websocket-serveriltä tuleva datastream on haettu
Angular-templaattiin kahdella eri tavalla.
*/

import { Component, OnInit } from '@angular/core';
import { WebsocketService } from './websocket.service';
import { Observable } from 'rxjs';
import { CommonModule } from '@angular/common';

@Component({
    selector: 'app-root',
    standalone: true,
    imports: [CommonModule],
    template: `<h2>Angular WebSocket</h2>
  <p>Käynnistä ws-serveri, reffaa tämä sivu ja tähän ilmaantuu<br>
   kaksi reaaliaikaista datastreamia serveriltä. Ensimmäinen<br>
   on merkkijono joka on tilattu subscribella. Toinen on observable<br>
   joka tilataan vasta templaatissa async-pipen avulla.</p> 
       <h3>{{realtimedata}}</h3>
        <!-- async -pipe mahdollistaa observablen esittämisen 
        templaatissa. async hoitaa siis subscriben homman-->
        <h3>{{realtimedata2 | async }}</h3>
  `})

export class AppComponent implements OnInit {

    realtimedata!: string; // Haetaan tähän stringinä.
    realtimedata2!: Observable<string>; // Haetaan tähän observablena.

    constructor(private wsService: WebsocketService) {
        
    }

    ngOnInit() {
    
         // kaksi tapaa hakea realtimedata
    
		// Haetaan observable servicestä, tilataan se ja otetaan data  
        // ulos observablesta muuttujaan realtimedata
        this.wsService.createSocketObservable().subscribe(
            data => this.realtimedata = data
            // tässä voisi päivittää diagrammia this.realtimedata:lla
        );
          
       // haetaan observable servicestä ja sijoitetaan se 
       // muuttujaan realtimedata2
       this.realtimedata2 = this.wsService.createSocketObservable();
    }
}
